import { CanvasLogicalWidth } from './Waveform';
import { MouseEvent } from 'react';

interface Point {
  x: number;
  y: number;
}

// TODO: add tests
export const mouseEventToCanvasX = (
  evt: MouseEvent<HTMLCanvasElement>
): number => {
  const rect = evt.currentTarget.getBoundingClientRect();
  const elementX = evt.clientX - rect.left;
  return (elementX * CanvasLogicalWidth) / rect.width;
};

// TODO: add tests
export const mouseEventToCanvasPoint = (
  evt: MouseEvent<HTMLCanvasElement>
): Point => {
  const rect = evt.currentTarget.getBoundingClientRect();
  const elementX = evt.clientX - rect.left;
  const elementY = evt.clientY - rect.top;

  return {
    x: (elementX * evt.currentTarget.width) / rect.width,
    y: (elementY * evt.currentTarget.height) / rect.height,
  };
};

// TODO: add tests
export const canvasXToFrame = (x: number, numFrames: number): number => {
  return Math.floor((x / CanvasLogicalWidth) * numFrames);
};
